# -*- coding: utf-8 -*-
"""
Created on Fri Mar 24 18:13:30 2017

@author: maruyama
"""


def CriaGameOfLife(Dimensao,NumGeracoes,Padrao,linp,colp):
    flag=False
    Matrix=[[False for y in range(Dimensao)] for x in range(Dimensao)]
    if Inicializa(Matrix,Padrao,linp,colp):
       PrintDisplay(Matrix)                        # estado inicial
       for k in range(1,NumGeracoes+1):
           input('Press enter to continue: ')
           Matrix = UpdateMatrix(Matrix)
           PrintDisplay(Matrix)
           # print  Matrix
       flag=True
    return(flag)
    # (linp,colp) coordenadas na Matriz A
    # onde o canto superior esquerdo do padrao deve coincidir
    #
def Inicializa(A,Padrao,linp,colp):
    # dimensoes da matriz A
    nlinesA = len(A)
    ncolsA  = len(A[0])
    # dimesoes do padrao
    nlinesPadrao=len(Padrao)
    ncolsPadrao =len(Padrao[0])
    
    flag=False
    # Testa se (linp,colp) e'uma coordenada valida na matriz
    if (linp in range(nlinesA)) and (colp in range(ncolsA)):
       if (linp+nlinesPadrao-1 in range(nlinesA)) and (colp+ncolsPadrao-1 in range(ncolsA)):
           flag=True
           for i in range(nlinesPadrao):
               for j in range(ncolsPadrao):
                   if Padrao[i][j]==1:
                      A[linp+i][colp+j]=True
                   else:
                      A[linp+i][colp+j]=False
    return(flag) # True se foi possivel inserir o padrao False caso contrario
    

def ContaVizinhos(Matrix, lin, col): # Conta o numero de celulas vizinhas que estao vivas
                                     # (lin,col) posicao da celula
    contador = 0
        # (lin,col) posicao da celula
        # Dimensoes do array Matrix nao sao conhecidos
        # Pressuposto que indices (lin,col) nao se referem a uma celula
        # na borda do array

    # coloque o seu codigo aqui


    return contador
        
def UpdateMatrix(MatrixVelha): # Calcula a nova geracao de celulas
    # recupero as dimensoes da matriz
    numlines = len(MatrixVelha)
    numcols  = len(MatrixVelha[0])
    # defino uma nova matrix de celulas com as mesmas dimensoes
    MatrixNova=[[False for y in range(numcols)] for x in range(numlines)]
                                          # a borda da matriz e' sempre False (celulas mortas)
    for i in range(1,numlines-1):         # comeca da segunda linha e termina na penultima linha
        for j in range(1,numcols-1):      # idem para colunas
          # Coloque aqui o seu código
          # contendo as regras de vida e morte
          # Utilize a funcao ContaVizinhos()
          MatrixNova[i][j]=MatrixVelha[i][j]          
    return MatrixNova
                    
def PrintDisplay(a):
    # recupera dimensoes do objeto a
    numlines = len(a)
    numcols  = len(a[0])
    print('Geracao')
    for i in range(numlines):
        for j in range(numcols):
            if a[i][j] == True:
                print('o ',end="")
            else:     #   it must be False of course !
                print('. ',end="")
        print(end="\n")
        
def Conversao(A):
    nlinesA = len(A)
    ncolsA  = len(A[0])    
    B=[['. ' for y in range(ncolsA)] for x in range(nlinesA)]
    for i in range(nlinesA):
        for j in range(ncolsA):
            if A[i][j] == True:
               B[i][j] = 'o '
    return(B)
    
# Devido a limitacoes da implementacao       
# Padrao nao pode ser uma unica linha
#       
blinker = [[0,0,0],[1,1,1],[0,0,0]]
# fonte http://www.math.cornell.edu/~lipa/mec/lesson6.html
toad = [[0,1,1,1],[1,1,1,0]]
#https://en.wikipedia.org/wiki/Conway%27s_Game_of_Life
tetrominoe = [[0,1,0],[1,1,1]] # Padrao vai aumentando de area
# fonte http://www.math.cornell.edu/~lipa/mec/lesson6.html
behived = [[1,0,0],[1,1,1]] # estabiliza em 3 geracoes
# fonte http://www.ibiblio.org/lifepatterns/october1970.html
smallexploder=[[0,1,0],[1,1,1],[1,0,1],[0,1,0]]
glider=[[0,1,0],[0,0,1],[1,1,1]] # desloca no sentido diagonal
cellrow=[[0,0,0,0,0,0,0,0,0,0],[1,1,1,1,1,1,1,1,1,1],[0,0,0,0,0,0,0,0,0,0]]
lightweightspaceship=[[0,1,1,1,1],[1,0,0,0,1],[0,0,0,0,1],[1,0,0,1,0]]
gosperglidergun=[[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0],
[0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0],
[0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,1,0,1,1,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]]

        
   